package
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.BitmapDataChannel;
	import flash.display.GradientType;
	import flash.display.SpreadMethod;
	import flash.display.Sprite;
	import flash.display.Shape;
	import flash.filters.BitmapFilter;
	import flash.filters.DisplacementMapFilter;
	import flash.filters.DisplacementMapFilterMode;
	import flash.filters.GlowFilter;
	import flash.geom.Matrix;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.events.Event;//Les venements "de bases", classe dont drive MouseEvent

	public class BackGround extends Sprite
	{
 		public var Fond:BitmapData = new BitmapData(128,96, false);
		private var Champ:BitmapData=new BitmapData(128,96,true,0x00000000);
		private var Cercle:Shape=new Shape();
		private var Affichage:Bitmap;
		private var Influence:Bitmap;
		private var Nb:int=0;
		private var StartValue:int;


		private var Size:int=30;

		public function BackGround()
		{

			StartValue=Math.random()*100;
            var matrix:Matrix = new Matrix();
            matrix.createGradientBox(Size,Size);
 			Cercle.graphics.beginGradientFill(GradientType.RADIAL,
				[0xFF0000, 0x00FF00],
				[100, 0],
				[55, 200],
				matrix,
				SpreadMethod.PAD);

			Champ.perlinNoise(128,96,4,StartValue+1,false,false,BitmapDataChannel.RED,false);


			Affichage = new Bitmap(Fond);
			Affichage.scaleX=Affichage.scaleY=5;
			this.addChild(Affichage);

			Influence=new Bitmap(Champ);
			Influence.scaleX=Influence.scaleY=5;
			addChild(Influence);
			Influence.alpha=.2

			this.addEventListener(Event.ENTER_FRAME,Anim_Fond);

		}

		public function StopBackGround():void
		{
			this.removeEventListener(Event.ENTER_FRAME,Anim_Fond);
			Anim_Fond();//L'appeler juste une fois, pour quand mme avoir un fond.
		}

		public function Anim_Fond(e:Event=null):void
		{
			Nb++;
			//public function perlinNoise(baseX:Number, baseY:Number, numOctaves:uint, randomSeed:int, stitch:Boolean, fractalNoise:Boolean, channelOptions:uint = 7, grayScale:Boolean = false, offsets:Array = null):void
			Fond.perlinNoise(128,96,3,StartValue,false,false,BitmapDataChannel.BLUE,false,new Array(new Point(Nb,0),new Point(Nb/2,0),new Point(Nb/4,0)));

 			Fond.applyFilter(Fond,new Rectangle(0,0,128,96),new Point(0,0),new DisplacementMapFilter(Champ,new Point(0,0),BitmapDataChannel.RED,BitmapDataChannel.RED,40,40,DisplacementMapFilterMode.CLAMP));
		}
    }
}
